## ukui-panel 3.0.3

=== CMakeLists.txt ===
﻿cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)
project(ukui-panel)

option(WITH_SCREENSAVER_FALLBACK "Include support for converting the deprecated 'screensaver' plugin to 'quicklaunch'. This requires the ukui-leave (ukui-session) to be installed in runtime." OFF)

#判断编译器类型,如果是gcc编译器,则在编译选项中加入c++11支持
if(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
    message(STATUS "optional:-std=c++11")   
endif(CMAKE_COMPILER_IS_GNUCXX)

# additional cmake files
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

macro(setByDefault VAR_NAME VAR_VALUE)
  if(NOT DEFINED ${VAR_NAME})
    set (${VAR_NAME} ${VAR_VALUE})
  endif(NOT DEFINED ${VAR_NAME})
endmacro()

include(GNUInstallDirs)

setByDefault(CUSTOM_QT_5_6_VERSION Yes)
setByDefault(CUSTOM_QT_5_12_VERSION No)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

set(REQUIRED_QT_VERSION "5.6.1")
set(KF5_MINIMUM_VERSION "5.18.0")
set(QT_MINIMUM_VERSION "5.6.1")
set(UKUI_MINIMUM_VERSION "0.14.1")
set(QTXDG_MINIMUM_VERSION "3.3.1")

find_package(Qt5DBus ${REQUIRED_QT_VERSION} REQUIRED)
find_package(Qt5LinguistTools ${REQUIRED_QT_VERSION} REQUIRED)
find_package(Qt5Widgets ${REQUIRED_QT_VERSION} REQUIRED)
find_package(Qt5X11Extras ${REQUIRED_QT_VERSION} REQUIRED)
find_package(Qt5Xml ${REQUIRED_QT_VERSION} REQUIRED)
find_package(KF5WindowSystem ${KF5_MINIMUM_VERSION} REQUIRED)
find_package(Qt5 ${QT_MINIMUM_VERSION} CONFIG REQUIRED Widgets DBus X11Extras LinguistTools)
find_package(Qt5Xdg ${QTXDG_MINIMUM_VERSION} REQUIRED)
find_package(X11 REQUIRED)
find_package(Qt5LinguistTools)

find_package(PkgConfig)
pkg_check_modules(Gsetting REQUIRED gsettings-qt)
include_directories(${Gsetting_INCLUDE_DIRS})
set(LIBRARIES
    ${Gsetting_LIBRARIES}
)

# Patch Version
set(UKUI_VERSION 3.0)
set(UKUI_PANEL_PATCH_VERSION 0)
set(UKUI_MAJOR_VERSION 3)
set(UKUI_MINOR_VERSION 0)

#set(UKUI_TRANSLATIONS_DIR "${CMAKE_INSTALL_FULL_DATAROOTDIR}/ukui/translations/")
set(UKUI_PANEL_VERSION ${UKUI_MAJOR_VERSION}.${UKUI_MINOR_VERSION}.${UKUI_PANEL_PATCH_VERSION})
add_definitions("-DUKUI_PANEL_VERSION=\"${UKUI_PANEL_VERSION}\"")

include(./cmake/ukui-build-tools/modules/UKUiPreventInSourceBuilds.cmake)
#include(./cmake/ukui-build-tools/modules/UKUiTranslate.cmake)

# All UKUiCompilerSettings except CMAKE_MODULE_LINKER_FLAGS work just fine
# So we reset only these Flags after loading UKUiCompilerSettings
# ukui-build-tools:
#  set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--no-undefined ${SYMBOLIC_FLAGS} ${CMAKE_MODULE_LINKER_FLAGS}")
message(STATUS "==OLD== CMAKE_MODULE_LINKER_FLAGS: ${CMAKE_MODULE_LINKER_FLAGS}")
set( OLD_CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "${OLD_CMAKE_MODULE_LINKER_FLAGS} ${SYMBOLIC_FLAGS}")

# Warning: This must be before add_subdirectory(panel). Move with caution.
set(PLUGIN_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/ukui-panel")
add_definitions(
    -DPLUGIN_DIR=\"${PLUGIN_DIR}\"
)
#Add PACKAGE_DATA_DIR
set(PACKAGE_DATA_DIR "/usr/share/ukui-panel")
add_definitions(
    -DPACKAGE_DATA_DIR=\"${PACKAGE_DATA_DIR}\"
)

message(STATUS "CMAKE Module linker flags: ${CMAKE_MODULE_LINKER_FLAGS}")
message(STATUS "Panel plugins location: ${PLUGIN_DIR}")

#########################################################################
# Plugin system
# You can enable/disable building of the plugin using cmake options.
#    cmake -DWORLDCLOCK_PLUGIN=Yes .. # Enable worldclock plugin
#    cmake -DWORLDCLOCK_PLUGIN=No ..  # Disable worldclock plugin

include("cmake/BuildPlugin.cmake")
include(./cmake/ukui-build-tools/modules/UKUiTranslateDesktop.cmake)
include(./cmake/ukui-build-tools/modules/UKUiTranslationLoader.cmake)
set(ENABLED_PLUGINS) # list of enabled plugins
set(STATIC_PLUGINS) # list of statically linked plugins

setByDefault(QUICKLAUNCH_PLUGIN Yes)
if(QUICKLAUNCH_PLUGIN)
    list(APPEND STATIC_PLUGINS "quicklaunch")
    add_definitions(-DWITH_QUICKLAUNCH_PLUGIN)
    list(APPEND ENABLED_PLUGINS "Quicklaunch")
    add_subdirectory(plugin-quicklaunch)
endif()


setByDefault(SHOWDESKTOP_PLUGIN Yes)
if(SHOWDESKTOP_PLUGIN)
    list(APPEND STATIC_PLUGINS "showdesktop")
    add_definitions(-DWITH_SHOWDESKTOP_PLUGIN)
    list(APPEND ENABLED_PLUGINS "Show Desktop")
    add_subdirectory(plugin-showdesktop)
endif()


setByDefault(TASKBAR_PLUGIN Yes)
if(TASKBAR_PLUGIN)
  list(APPEND STATIC_PLUGINS "taskbar")
  add_definitions(-DWITH_TASKBAR_PLUGIN)
  list(APPEND ENABLED_PLUGINS "Taskbar")
  add_subdirectory(plugin-taskbar)
endif()

add_subdirectory(ukui-flash-disk)

setByDefault(TRAY_PLUGIN Yes)
if(TRAY_PLUGIN)
    list(APPEND STATIC_PLUGINS "tray")
    add_definitions(-DWITH_TRAY_PLUGIN)
    list(APPEND ENABLED_PLUGINS "System Tray")
    add_subdirectory(plugin-tray)
endif()


setByDefault(SPACER_PLUGIN Yes)
if(SPACER_PLUGIN)
    list(APPEND STATIC_PLUGINS "spacer")
    add_definitions(-DWITH_SPACER_PLUGIN)
    list(APPEND ENABLED_PLUGINS "Spacer")
    add_subdirectory(plugin-spacer)
endif()

setByDefault(CALENDAR_PLUGIN Yes)
if(CALENDAR_PLUGIN)
    list(APPEND ENABLED_PLUGINS "calendar")
    add_subdirectory(plugin-calendar)
endif(CALENDAR_PLUGIN)

setByDefault(STARTMENU_PLUGIN Yes)
if(STARTMENU_PLUGIN)
    list(APPEND ENABLED_PLUGINS "startmenu")
    add_subdirectory(plugin-startmenu)
endif(STARTMENU_PLUGIN)

setByDefault(NIGHTMODE_PLUGIN Yes)
if(NIGHTMODE_PLUGIN)
    list(APPEND ENABLED_PLUGINS "nightmode")
    add_subdirectory(plugin-nightmode)
endif(NIGHTMODE_PLUGIN)

setByDefault(TASKVIEW_PLUGIN Yes)
if(TASKVIEW_PLUGIN)
    list(APPEND ENABLED_PLUGINS "taskview")
    add_subdirectory(plugin-taskview)
endif(TASKVIEW_PLUGIN)

setByDefault(SEGMENTATION_PLUGIN Yes)
if(SEGMENTATION_PLUGIN)
    list(APPEND ENABLED_PLUGINS "segmentation")
    add_subdirectory(plugin-segmentation)
endif(SEGMENTATION_PLUGIN)

#########################################################################

message(STATUS  "**************** The following plugins will be built ****************")
foreach (PLUGIN_STR ${ENABLED_PLUGINS})
    message(STATUS "  ${PLUGIN_STR}")
endforeach()
message(STATUS "*********************************************************************")

add_subdirectory(panel)

file(GLOB_RECURSE QRC_SOURCE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.qrc)

# translation
set(UKUI_TRANSLATIONS_DIR ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/ukui/)
add_definitions(
    -DUKUI_TRANSLATIONS_DIR="${UKUI_TRANSLATIONS_DIR}"
)
if (NOT DEFINED UPDATE_TRANSLATIONS)
    set(UPDATE_TRANSLATIONS "No")
endif()

# To create a new ts file: lupdate -recursive . -target-language zh_CN -ts panel/resources/ukui-panel_zh_CN.ts
file(GLOB TS_FILES "${CMAKE_CURRENT_SOURCE_DIR}/panel/resources/*.ts")

# cmake -DUPDATE_TRANSLATIONS=yes
if (UPDATE_TRANSLATIONS)
    qt5_create_translation(QM_FILES ${CMAKE_SOURCE_DIR} ${TS_FILES})
else()
    qt5_add_translation(QM_FILES ${TS_FILES})
endif()
add_custom_target(translations ALL DEPENDS ${QM_FILES})
install(FILES ${QM_FILES} DESTINATION ${UKUI_TRANSLATIONS_DIR})

=== panel/CMakeLists.txt ===
set(PROJECT ukui-panel)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

add_subdirectory(common)
#add_subdirectory(xdg)

set(PRIV_HEADERS
    panelpluginsmodel.h
    windownotifier.h
    ukuipanel.h
    ukuipanelapplication.h
    ukuipanelapplication_p.h
    ukuipanellayout.h
    plugin.h
    pluginsettings_p.h
    ukuipanellimits.h
    popupmenu.h
    pluginmoveprocessor.h
    ukuipanelpluginconfigdialog.h
    config/configpaneldialog.h
    config/configpanelwidget.h
    config/configpluginswidget.h
    config/addplugindialog.h
    highlight-effect.h
)

# using UKUi namespace in the public headers.
set(PUB_HEADERS
    ukuipanelglobals.h
    pluginsettings.h
    iukuipanelplugin.h
    iukuipanel.h
    comm_func.h

    common/ukuihtmldelegate.h
    common/ukuisettings.h
    common/ukuiplugininfo.h
    common/ukuiapplication.h
    common/ukuisingleapplication.h
    common/ukuitranslator.h
    common/ukuiprogramfinder.h

    common/configdialog/ukuiconfigdialog.h
    common/configdialog/ukuiconfigdialogcmdlineoptions.h
    common/configdialog/ukuipageselectwidget.h

    common/ukuinotification.h
    common/ukuiautostartentry.h
    common/ukuigridlayout.h
    common/ukuirotatedwidget.h
    common/ukuiglobals.h
    ukuicontrolstyle.h
    highlight-effect.cpp
    customstyle.h
)

set(SOURCES
    main.cpp
    panelpluginsmodel.cpp
    windownotifier.cpp
    ukuipanel.cpp
    ukuipanelapplication.cpp
    ukuipanellayout.cpp
    plugin.cpp
    pluginsettings.cpp
    popupmenu.cpp
    pluginmoveprocessor.cpp
    ukuipanelpluginconfigdialog.cpp
    config/configpaneldialog.cpp
    config/configpanelwidget.cpp
    config/configpluginswidget.cpp
    config/addplugindialog.cpp
    comm_func.cpp

    common/ukuihtmldelegate.cpp
    common/ukuiplugininfo.cpp
    common/ukuisettings.cpp
    common/ukuiapplication.cpp
    common/ukuisingleapplication.cpp
    common/ukuitranslator.cpp
    common/ukuiprogramfinder.cpp

    common/configdialog/ukuiconfigdialog.cpp
    common/configdialog/ukuiconfigdialogcmdlineoptions.cpp
    common/configdialog/ukuipageselectwidget.cpp

    common/ukuiautostartentry.cpp
    common/ukuinotification.cpp
    common/ukuigridlayout.cpp
    common/ukuirotatedwidget.cpp
    ukuicontrolstyle.cpp
    customstyle.cpp
)

set(UI
    config/configpanelwidget.ui
    config/configpluginswidget.ui
    config/addplugindialog.ui
    common/configdialog/ukuiconfigdialog.ui
)


file(GLOB CONFIG_FILES resources/*.conf resources/*.qss)
############################################

add_definitions(-DCOMPILE_UKUI_PANEL)

set(PLUGIN_DESKTOPS_DIR "${CMAKE_INSTALL_FULL_DATAROOTDIR}/ukui/${PROJECT}")
add_definitions(-DPLUGIN_DESKTOPS_DIR=\"${PLUGIN_DESKTOPS_DIR}\")

if (WITH_SCREENSAVER_FALLBACK)
    message(STATUS "Building with conversion of deprecated 'screensaver' plugin")
    add_definitions(-DWITH_SCREENSAVER_FALLBACK "-DUKUI_LOCK_DESKTOP=\"${CMAKE_INSTALL_FULL_DATAROOTDIR}/applications/ukui-lockscreen.desktop\"")
endif ()

project(${PROJECT})

set(QTX_LIBRARIES Qt5::Widgets Qt5::Xml Qt5::DBus)

 #Translations
#ukui_translate_ts(QM_FILES SOURCES
#    UPDATE_TRANSLATIONS
#        ${UPDATE_TRANSLATIONS}
#    SOURCES
#        ${PUB_HEADERS}
#        ${PRIV_HEADERS}
#        ${SOURCES}
#        ${UI}
#    INSTALL_DIR
#    "${UKUI_TRANSLATIONS_DIR}/${PROJECT_NAME}"
#)

ukui_app_translation_loader(SOURCES ${PROJECT_NAME})


QT5_ADD_DBUS_INTERFACE(DBUS_INTERFACE_SRCS
    common/dbus/org.freedesktop.Notifications.xml
    notifications_interface
)

QT5_ADD_DBUS_ADAPTOR(DBUS_ADAPTOR_SRCS
    common/dbus/org.ukui.SingleApplication.xml
    common/ukuisingleapplication.h UKUi::SingleApplication
)

set_property(SOURCE ${DBUS_INTERFACE_SRCS} ${DBUS_ADAPTOR_SRCS} PROPERTY SKIP_AUTOGEN ON)
list(APPEND SOURCES "${DBUS_INTERFACE_SRCS}" "${DBUS_ADAPTOR_SRCS}")




add_executable(${PROJECT}
    ${PUB_HEADERS}
    ${PRIV_HEADERS}
    ${QM_FILES}
    ${SOURCES}
    ${UI}
)
find_package(PkgConfig)
pkg_check_modules(GLIB2 REQUIRED glib-2.0)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
pkg_check_modules(Gsetting REQUIRED gsettings-qt)
include_directories(${GLIB2_INCLUDE_DIRS})
include_directories(${GIO2_INCLUDE_DIRS})
include_directories(${Gsetting_INCLUDE_DIRS})
#ADD_DEFINITIONS(-DQT_NO_KEYWORDS)
target_link_libraries(${PROJECT}
    ${LIBRARIES}
    ${QTX_LIBRARIES}
    KF5::WindowSystem
    ${STATIC_PLUGINS}
    Qt5Xdg
    ${GLIB2_LIBRARIES}
    ${GIO2_LIBRARIES}
    ${Gsetting_LIBRARIES}
)


target_compile_definitions(${PROJECT}
    PRIVATE
        "UKUI_RELATIVE_SHARE_DIR=\"${UKUI_RELATIVE_SHARE_DIR}\""
        #"UKUI_SHARE_DIR=\"${UKUI_SHARE_DIR}\""
        "UKUI_RELATIVE_SHARE_TRANSLATIONS_DIR=\"${UKUI_RELATIVE_TRANSLATIONS_DIR}\""
        "UKUI_SHARE_TRANSLATIONS_DIR=\"${UKUI_TRANSLATIONS_DIR}\""
        "UKUI_GRAPHICS_DIR=\"${UKUI_GRAPHICS_DIR}\""
        #"UKUI_ETC_XDG_DIR=\"${UKUI_ETC_XDG_DIR}\""
        "UKUI_DATA_DIR=\"${UKUI_DATA_DIR}\""   
        "UKUI_INSTALL_PREFIX=\"${CMAKE_INSTALL_PREFIX}\""
        #"UKUI_VERSION=\"${UKUI_VERSION}\""
        #"COMPILE_LIBUKUI"
        #"QT_USE_QSTRINGBUILDER"
        #"QT_NO_CAST_FROM_ASCII"
        #"QT_NO_CAST_TO_ASCII"
        #"QT_NO_URL_CAST_FROM_STRING"
        #"QT_NO_CAST_FROM_BYTEARRAY"
        #"$<$<CONFIG:Release>:QT_NO_DEBUG_OUTPUT>"
        #"$<$<CONFIG:Release>:QT_NO_WARNING_OUTPUT>"
)


install(TARGETS ${PROJECT} RUNTIME DESTINATION bin)
install(FILES ${CONFIG_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/ukui)
install(FILES ${PUB_HEADERS} DESTINATION include/ukui)
install(FILES
    ../man/ukui-panel.1
    DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
    COMPONENT Runtime
)
install(FILES
    resources/ukui-panel.desktop
    DESTINATION "/etc/xdg/autostart/"
    COMPONENT Runtime
)

install(DIRECTORY
	./img/
    DESTINATION "${PACKAGE_DATA_DIR}/panel/img"
)

install(FILES
    resources/ukui-panel_zh_CN.qm resources/ukui-panel_zh_CN.ts resources/ukui-panel_tr.ts
    DESTINATION "${PACKAGE_DATA_DIR}/panel/resources"
    COMPONENT Runtime
)

install(FILES
    resources/org.ukui.panel.settings.gschema.xml
    DESTINATION "/usr/share/glib-2.0/schemas"
    COMPONENT Runtime
)

=== plugin-nightmode/CMakeLists.txt ===
set(PLUGIN "nightmode")

set(HEADERS
    nightmode.h
)

set(SOURCES
    nightmode.cpp
)

set(LIBRARIES
#    Qt5Xdg
    ${Gsetting_LIBRARIES}
)

BUILD_UKUI_PLUGIN(${PLUGIN})

=== plugin-quicklaunch/CMakeLists.txt ===
set(PLUGIN "quicklaunch")

set(HEADERS
    ukuiquicklaunchplugin.h
    ukuiquicklaunch.h
    quicklaunchbutton.h
    quicklaunchaction.h
#    ../panel/customstyle.h
)

set(SOURCES
    ukuiquicklaunchplugin.cpp
    ukuiquicklaunch.cpp
    quicklaunchbutton.cpp
    quicklaunchaction.cpp
#    ../panel/customstyle.cpp
)

find_package(PkgConfig)
pkg_check_modules(GIOUNIX2 REQUIRED gio-unix-2.0)

include_directories(
    ${UKUI_INCLUDE_DIRS}
    "${CMAKE_CURRENT_SOURCE_DIR}/../panel"
    ${GIOUNIX2_INCLUDE_DIRS}
)

set(LIBRARIES
    Qt5Xdg
    ${GIOUNIX2_LIBRARIES}
)

BUILD_UKUI_PLUGIN(${PLUGIN})

=== plugin-showdesktop/CMakeLists.txt ===
set(PLUGIN "showdesktop")

set(HEADERS
    showdesktop.h
)

set(SOURCES
    showdesktop.cpp
)

set(LIBRARIES
    ${LIBRARIES}
    Qt5Xdg
)

BUILD_UKUI_PLUGIN(${PLUGIN})

=== plugin-spacer/CMakeLists.txt ===
set(PLUGIN "spacer")

set(HEADERS
    spacer.h
    spacerconfiguration.h
)

set(SOURCES
    spacer.cpp
    spacerconfiguration.cpp
)

set(UIS
    spacerconfiguration.ui
)

BUILD_UKUI_PLUGIN(${PLUGIN})

=== plugin-taskbar/CMakeLists.txt ===
set(PLUGIN "taskbar")

set(HEADERS
    ukuitaskbar.h
    ukuitaskbutton.h
    ukuitaskbarplugin.h
    ukuitaskgroup.h
    ukuigrouppopup.h
    ukuitaskwidget.h
    ukuitaskclosebutton.h
	ukuitaskbaricon.h
)

set(SOURCES
    ukuitaskbar.cpp
    ukuitaskbutton.cpp
    ukuitaskbarplugin.cpp
    ukuitaskgroup.cpp
    ukuigrouppopup.cpp
    ukuitaskwidget.cpp
    ukuitaskclosebutton.cpp
    ukuitaskbaricon.cpp
)

find_package(X11 REQUIRED)

set(LIBRARIES
    ${X11_LIBRARIES}
    Qt5X11Extras
)

pkg_check_modules(GLIB2 REQUIRED glib-2.0 gio-2.0)
include_directories(${GLIB2_INCLUDE_DIRS})
#for <QDBusInterface>
include_directories(${_Qt5DBus_OWN_INCLUDE_DIRS})

BUILD_UKUI_PLUGIN(${PLUGIN})

=== plugin-tray/CMakeLists.txt ===
set(PLUGIN "tray")

include(CheckLibraryExists)

#find_package(XCB REQUIRED COMPONENTS xcb xcb-util xcb-damage)
find_package(PkgConfig)

find_package(X11 REQUIRED)
find_package(Qt5X11Extras ${REQUIRED_QT_VERSION} REQUIRED)
pkg_check_modules(XCOMPOSITE REQUIRED xcomposite)
pkg_check_modules(XDAMAGE REQUIRED xdamage)
pkg_check_modules(XRENDER REQUIRED xrender)
pkg_check_modules(Gsetting REQUIRED gsettings-qt)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
pkg_check_modules(GIOUNIX2 REQUIRED gio-unix-2.0)
pkg_check_modules(DCONF REQUIRED dconf)


include_directories(${Gsetting_INCLUDE_DIRS})
include_directories(${GIO2_INCLUDE_DIRS})
include_directories(${GIOUNIX2_INCLUDE_DIRS})
include_directories(${DCONF_INCLUDE_DIRS})

set(HEADERS
    ukuitrayplugin.h
    ukuitray.h
    trayicon.h
    xfitman.h
    ukuitraystrage.h
)

set(SOURCES
    ukuitrayplugin.cpp
    ukuitray.cpp
    trayicon.cpp
    xfitman.cpp
    ukuitraystrage.cpp
)

set(LIBRARIES
    ${X11_LIBRARIES}
    ${XCOMPOSITE_LDFLAGS}
    ${XDAMAGE_LIBRARIES}
    ${XRENDER_LIBRARIES}
    ${XCB_LIBRARIES}
    Qt5X11Extras
    ${Gsetting_LIBRARIES}
    ${GIO2_LIBRARIES}
    ${GIOUNIX2_LIBRARIES}
    ${DCONF_LIBRARIES}
)

install(FILES
    ../panel/resources/org.ukui.panel.tray.gschema.xml
    DESTINATION "/usr/share/glib-2.0/schemas/"
    COMPONENT Runtime
)
BUILD_UKUI_PLUGIN(${PLUGIN})

=== ukui-flash-disk/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(ukui-flash-disk)

#判断编译器类型,如果是gcc编译器,则在编译选项中加入c++11支持
if(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
    message(STATUS "optional:-std=c++11")
endif(CMAKE_COMPILER_IS_GNUCXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if(CMAKE_VERSION VERSION_LESS "3.7.0")
    set(CMAKE_INCLUDE_CURRENT_DIR ON)
endif()

find_package(Qt5 COMPONENTS Widgets REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(PkgConfig REQUIRED)

pkg_check_modules(GLIB2 REQUIRED glib-2.0 gio-2.0)
pkg_check_modules(QGS REQUIRED gsettings-qt)


include_directories(${GLIB2_INCLUDE_DIRS})
include_directories(${QGS_INCLUDE_DIRS})
add_executable(ukui-flash-disk
    ukui-flash-disk.qrc
    disk-resources/ukui-flash-disk_zh_CN.ts
    disk-resources/ukui-flash-disk_tr.ts
    main.cpp
    mainwindow.cpp
    qclickwidget.cpp
    qclickwidget.h
    UnionVariable.cpp
    UnionVariable.h
    ejectInterface.cpp
    ejectInterface.h
    clickLabel.h
    clickLabel.cpp
    MainController.h
    MainController.cpp
    MacroFile.h
        mainwindow.ui
        mainwindow.h
)

add_definitions(-DQT_NO_KEYWORDS)

target_link_libraries(${PROJECT_NAME}  Qt5::Widgets Qt5::DBus ${GLIB2_LIBRARIES} ${QGS_LIBRARIES})

install(TARGETS ukui-flash-disk DESTINATION bin)

install(FILES
    disk-resources/ukui-flash-disk.desktop
    DESTINATION "/etc/xdg/autostart/"
    COMPONENT Runtime
)

install(FILES
    ukui-flash-disk.qrc disk-resources/ukui-flash-disk_zh_CN.qm disk-resources/ukui-flash-disk_tr.qm
    DESTINATION "/usr/share/ukui/ukui-panel/"
    COMPONENT Runtime
)

=== panel/common/CMakeLists.txt ===

set(UKUIBT_MINIMUM_VERSION "0.6.0")
set(KF5_MINIMUM_VERSION "5.36.0")
set(QT_MINIMUM_VERSION "5.7.1")
set(QTXDG_MINIMUM_VERSION "3.3.1")

# Major UKUi Version, belong to all components
set(UKUI_MAJOR_VERSION 0)
# Minor UKUi Version, belong to all components
set(UKUI_MINOR_VERSION 14)
#
# Patch Version, belong *only* to the component
# UKUi is 0.13 - libukui is at patch version 0
# The official UKUi version will follow libukui.
#
# In a perfect world all components would have the same major- and minor- and
# patch-version as libukui - in real life it will be fine if every component
# has it's own patch version within a major/minor life cyle.
#
set(UKUI_PATCH_VERSION 1)
set(UKUI_VERSION ${UKUI_MAJOR_VERSION}.${UKUI_MINOR_VERSION}.${UKUI_PATCH_VERSION})


option(UPDATE_TRANSLATIONS "Update source translation translations/*.ts files" OFF)


#find_package(ukui-build-tools ${UKUIBT_MINIMUM_VERSION} REQUIRED)
#find_package(Qt5 ${QT_MINIMUM_VERSION} CONFIG REQUIRED Widgets DBus X11Extras LinguistTools)
#find_package(Qt5Xdg ${QTXDG_MINIMUM_VERSION} REQUIRED)
#find_package(KF5WindowSystem ${KF5_MINIMUM_VERSION} REQUIRED)
#find_package(PolkitQt5-1 REQUIRED)
#find_package(X11 REQUIRED)
message(STATUS "Building ${PROJECT_NAME} with Qt ${Qt5Core_VERSION}")

include(CMakePackageConfigHelpers)
include(GNUInstallDirs) # Standard directories for installation

#add_subdirectory(ukuibacklight/linux_backend/driver)

set(UKUI_PKG_CONFIG_DESCRIPTION "Shared library for UKUi applications")

set(HEADERS
    ukuihtmldelegate.h
    ukuisettings.h
    ukuiplugininfo.h
    ukuipowermanager.h
    ukuiscreensaver.h
    ukuiapplication.h
    ukuisingleapplication.h
    ukuitranslator.h
    ukuiprogramfinder.h

    configdialog/ukuiconfigdialog.h
    configdialog/ukuiconfigdialogcmdlineoptions.h
    configdialog/ukuipageselectwidget.h

    ukuipower/ukuipower.h
    ukuinotification.h
    ukuiautostartentry.h
    ukuigridlayout.h
    ukuirotatedwidget.h
    ukuiglobals.h
    ukuibacklight.h
    #ukuibacklight/virtual_backend.h
    #ukuibacklight/linux_backend/linuxbackend.h
)

set(PUBLIC_CLASSES
    HtmlDelegate
    Settings
    PluginInfo
    PowerManager
    ScreenSaver
    Application
    SingleApplication
    Translator
    ProgramFinder

    ConfigDialog
    ConfigDialogCmdLineOptions
    PageSelectWidget

    Power
    Notification
    AutostartEntry
    GridLayout
    RotatedWidget
    Globals
    Backlight
)

set(SOURCES
    ukuihtmldelegate.cpp
    ukuiplugininfo.cpp
    ukuipowermanager.cpp
    ukuisettings.cpp
    ukuiscreensaver.cpp
    ukuiapplication.cpp
    ukuisingleapplication.cpp
    ukuitranslator.cpp
    ukuiprogramfinder.cpp

    configdialog/ukuiconfigdialog.cpp
    configdialog/ukuiconfigdialogcmdlineoptions.cpp
    configdialog/ukuipageselectwidget.cpp

    ukuipower/ukuipower.cpp
    ukuipower/ukuipowerproviders.cpp
    ukuiautostartentry.cpp
    ukuinotification.cpp
    ukuigridlayout.cpp
    ukuirotatedwidget.cpp
    ukuibacklight.cpp
    ukuibacklight/virtual_backend.cpp
    ukuibacklight/linux_backend/linuxbackend.cpp
)

set(MOCS
    ukuihtmldelegate.h
    ukuipowermanager.h
    ukuisettings.h
    ukuiscreensaver.h
    ukuiapplication.h
    ukuibacklight.h

    configdialog/ukuiconfigdialog.h
    configdialog/ukuiconfigdialog_p.h
    configdialog/ukuipageselectwidget.h

    ukuinotification.h
    ukuinotification_p.h
    ukuipower/ukuipower.h
    ukuipower/ukuipowerproviders.h
    ukuigridlayout.h
    ukuirotatedwidget.h
    ukuibacklight/virtual_backend.h
    ukuibacklight/linux_backend/linuxbackend.h
)

set(FORMS
    configdialog/ukuiconfigdialog.ui
)

set(POLKIT_FILES
    "${CMAKE_CURRENT_BINARY_DIR}/org.ukui.backlight.pkexec.policy"
)

# Build Polkit file
configure_file ( polkit/org.ukui.backlight.pkexec.policy.in "${CMAKE_CURRENT_BINARY_DIR}/org.ukui.backlight.pkexec.policy" )

file(GLOB UKUI_CONFIG_FILES resources/*.conf)

QT5_ADD_DBUS_INTERFACE(DBUS_INTERFACE_SRCS
    dbus/org.freedesktop.Notifications.xml
    notifications_interface
)

QT5_ADD_DBUS_ADAPTOR(DBUS_ADAPTOR_SRCS
    dbus/org.ukui.SingleApplication.xml
    ukuisingleapplication.h UKUi::SingleApplication
)

set_property(SOURCE ${DBUS_INTERFACE_SRCS} ${DBUS_ADAPTOR_SRCS} PROPERTY SKIP_AUTOGEN ON)
list(APPEND SOURCES "${DBUS_INTERFACE_SRCS}" "${DBUS_ADAPTOR_SRCS}")

# KF5WindowSystem is missing here. KF5WindowSystem doesn't provide an .pc file.
set(UKUI_PKG_CONFIG_REQUIRES "Qt5Xdg >= ${QTXDG_MINIMUM_VERSION}, Qt5Widgets >= ${QT_MINIMUM_VERSION}, Qt5Xml >= ${QT_MINIMUM_VERSION}, Qt5DBus >= ${QT_MINIMUM_VERSION}, Qt5X11Extras >= ${QT_MINIMUM_VERSION}")


# Standard directories for installation
include(../../cmake/ukui-build-tools/modules/UKUiPreventInSourceBuilds.cmake)
include(../../cmake/ukui-build-tools/modules/UKUiCompilerSettings.cmake)
include(../../cmake/ukui-build-tools/modules/UKUiCreatePkgConfigFile.cmake)
include(../../cmake/ukui-build-tools/modules/UKUiCreatePortableHeaders.cmake)
include(../../cmake/ukui-build-tools/modules/UKUiConfigVars.cmake)

set(UKUI_INTREE_INCLUDE_DIR "${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/include")

set(UKUI_INSTALL_INCLUDE_DIR "${CMAKE_INSTALL_FULL_INCLUDEDIR}/${UKUI_LIBRARY_NAME}")
set(UKUI_INSTALL_CMAKE_DIR "${CMAKE_INSTALL_FULL_DATAROOTDIR}/cmake")


## Translations

#include(../cmake/ukui-build-tools/modules/UKUiTranslateTs.cmake)

#ukui_translate_ts(QM_FILES
#   UPDATE_TRANSLATIONS
#       ${UPDATE_TRANSLATIONS}
#   SOURCES
#       ${SRCS}
#        ${FORMS}
#    INSTALL_DIR
#        "${UKUI_TRANSLATIONS_DIR}/${PROJECT_NAME}"
#)

message(STATUS "")
message(STATUS "libukui version: ${UKUI_VERSION}")
message(STATUS "")


# Copy public headers
foreach(h ${HEADERS})
    get_filename_component(bh ${h} NAME)
    configure_file(${h} "${UKUI_INTREE_INCLUDE_DIR}/UKUi/${bh}" COPYONLY)
endforeach()

# Create the portable headers
ukui_create_portable_headers(INTREE_PORTABLE_HEADERS
    NAME_PREFIX "ukui"
    OUTPUT_DIR "${UKUI_INTREE_INCLUDE_DIR}/UKUi"
    HEADER_NAMES ${PUBLIC_CLASSES}
)

#check_portable_headers(H_FILES ${PUB_HDRS} LINKS "${INTREE_PORTABLE_HEADERS}")

#************************************************
# Create in-tree build infrastructure
#************************************************
set(CFG_UKUI_TARGETS_FILE   "${UKUI_INTREE_TARGETS_FILE}")

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/ukui-config.cmake.in"
    "${CMAKE_BINARY_DIR}/${UKUI_LIBRARY_NAME}-config.cmake"
    INSTALL_DESTINATION "neverland"     # required, altough we don't install it
)

#************************************************
# Create installable build infrastructure
#************************************************
set(CFG_UKUI_TARGETS_FILE "${UKUI_INSTALL_CMAKE_DIR}/${UKUI_LIBRARY_NAME}/${UKUI_LIBRARY_NAME}-targets.cmake")

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/ukui-config.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/install/${UKUI_LIBRARY_NAME}-config.cmake"
    INSTALL_DESTINATION "${UKUI_INSTALL_CMAKE_DIR}/${UKUI_LIBRARY_NAME}"
)

write_basic_package_version_file(
    "${CMAKE_BINARY_DIR}/${UKUI_LIBRARY_NAME}-config-version.cmake"
    VERSION ${UKUI_VERSION}
    COMPATIBILITY AnyNewerVersion
)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/install/${UKUI_LIBRARY_NAME}-config.cmake"
    "${CMAKE_BINARY_DIR}/${UKUI_LIBRARY_NAME}-config-version.cmake"
    DESTINATION "${UKUI_INSTALL_CMAKE_DIR}/${UKUI_LIBRARY_NAME}"
    COMPONENT Devel
)

#install(EXPORT
#    ${UKUI_LIBRARY_NAME}-targets
#    DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${UKUI_LIBRARY_NAME}"
#    COMPONENT Devel
#)


if (Qt5Core_VERSION VERSION_LESS "5.9.0")
    if (NOT DEFINED WITH_XDG_DIRS_FALLBACK)
        set(WITH_XDG_DIRS_FALLBACK ON)
    endif ()
elseif (WITH_XDG_DIRS_FALLBACK)
    set(WITH_XDG_DIRS_FALLBACK OFF)
    message(WARNING "Disabling requested WITH_XDG_DIRS_FALLBACK workaround, as proper implementation is in Qt from v5.9.0")
endif ()
if (WITH_XDG_DIRS_FALLBACK)
    message(STATUS "Building with homemade QSettings XDG fallback workaround")

setByDefault(CUSTOM_QT_5_12_VERSION Yes)
if (CUSTOM_QT_5_12_VERSION )
	#target_compile_definitions(${UKUI_LIBRARY_NAME}
	#PRIVATE "WITH_XDG_DIRS_FALLBACK"
	#)
endif(CUSTOM_QT_5_12_VERSION)
endif ()

#install(FILES
   # ${PUB_HDRS}
  #  DESTINATION "${UKUI_INSTALL_INCLUDE_DIR}/UKUi"
 #   COMPONENT Devel
#)

#install(FILES
   # ${INTREE_PORTABLE_HEADERS}
  #  DESTINATION "${UKUI_INSTALL_INCLUDE_DIR}/UKUi"
 #   COMPONENT Devel
#)

#install(FILES ${UKUI_CONFIG_FILES}
  #  DESTINATION "${CMAKE_INSTALL_FULL_DATADIR}/ukui"
 #   COMPONENT Runtime
#)

#install(FILES ${POLKIT_FILES} DESTINATION "${POLKITQT-1_POLICY_FILES_INSTALL_DIR}")

#************************************************
# Create and install pkgconfig file
#************************************************
ukui_create_pkgconfig_file(
    PACKAGE_NAME ${UKUI_LIBRARY_NAME}
    DESCRIPTIVE_NAME ${UKUI_LIBRARY_NAME}
    DESCRIPTION ${UKUI_PKG_CONFIG_DESCRIPTION}
    INCLUDEDIRS ${UKUI_LIBRARY_NAME}
    REQUIRES ${UKUI_PKG_CONFIG_REQUIRES}
    VERSION ${UKUI_VERSION}
    INSTALL
)
#************************************************

=== panel/xdg/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)
# CMP0000: Call the cmake_minimum_required() command at the beginning of the top-level
# CMakeLists.txt file even before calling the project() command.
# The cmake_minimum_required(VERSION) command implicitly invokes the cmake_policy(VERSION)
# command to specify that the current project code is written for the given range of CMake
# versions.
project(libqtxdg)

option(BUILD_TESTS "Builds tests" OFF)
option(BUILD_DEV_UTILS "Builds and install development utils" OFF)

# additional cmake files
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

set(QTXDG_MAJOR_VERSION 3)
set(QTXDG_MINOR_VERSION 4)
set(QTXDG_PATCH_VERSION 0)
set(QTXDG_VERSION_STRING ${QTXDG_MAJOR_VERSION}.${QTXDG_MINOR_VERSION}.${QTXDG_PATCH_VERSION})

set(UKUIBT_MINIMUM_VERSION "0.6.0")
set(QT_MINIMUM_VERSION "5.6.1")
set(GLIB_MINIMUM_VERSION "2.41.0") # Mime Apps new implementation

#find_package(ukui-build-tools ${UKUIBT_MINIMUM_VERSION} REQUIRED)
find_package(Qt5 ${QT_MINIMUM_VERSION} CONFIG REQUIRED Widgets Svg Xml DBus)
find_package(GLIB ${GLIB_MINIMUM_VERSION} REQUIRED COMPONENTS gobject gio gio-unix)
#temp
find_package(PkgConfig)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
pkg_check_modules(GIOUNIX2 REQUIRED gio-unix-2.0)
include_directories(${GIO2_INCLUDE_DIRS})
include_directories(${GIOUNIX2_INCLUDE_DIRS})
set(LIBRARIES
    ${GIO2_LIBRARIES}
    ${GIOUNIX2_LIBRARIES}
)

include(GNUInstallDirs)             # Standard directories for installation
include(CMakePackageConfigHelpers)
include(GenerateExportHeader)

include(../../cmake/ukui-build-tools/modules/UKUiPreventInSourceBuilds.cmake)
include(../../cmake/ukui-build-tools/modules/UKUiCreatePkgConfigFile.cmake)
include(../../cmake/ukui-build-tools/modules/UKUiCreatePortableHeaders.cmake)
include(../../cmake/ukui-build-tools/modules/UKUiCompilerSettings.cmake NO_POLICY_SCOPE)

# Add link optimizations. It make the .so around 33% smaller without any known
# drawback.
include(compiler_settings NO_POLICY_SCOPE)

set(CMAKE_AUTOMOC ON)

if (BUILD_TESTS)
    find_package(Qt5 ${QT_MINIMUM_VERSION} CONFIG REQUIRED Test)
endif()


set(QTXDGX_LIBRARY_NAME "Qt5Xdg")
set(QTXDGX_FILE_NAME "qt5xdg")

set(QTXDGX_ICONLOADER_LIBRARY_NAME "Qt5XdgIconLoader")
set(QTXDGX_ICONLOADER_FILE_NAME "qt5xdgiconloader")
set(QTXDGX_ICONENGINEPLUGIN_LIBRARY_NAME "Qt5XdgIconPlugin")

set(QTXDGX_PKG_CONFIG_DESCRIPTION "Qt5Xdg, a Qt5 implementation of XDG standards")
set(QTXDGX_PKG_CONFIG_REQUIRES "Qt5Core >= ${QT_MINIMUM_VERSION}, Qt5Xml >= ${QT_MINIMUM_VERSION}, Qt5Widgets >= ${QT_MINIMUM_VERSION}, Qt5DBus >= ${QT_MINIMUM_VERSION}, Qt5XdgIconLoader = ${QTXDG_VERSION_STRING}")

set(QTXDGX_ICONLOADER_PKG_CONFIG_DESCRIPTION "Qt5XdgIconLader, a Qt5 XDG Icon Loader")
set(QTXDGX_ICONLOADER_PKG_CONFIG_REQUIRES "Qt5Gui >= ${QT_MINIMUM_VERSION}, Qt5Svg >= ${QT_MINIMUM_VERSION}")

set(QTXDGX_INTREE_INCLUDEDIR "${CMAKE_CURRENT_BINARY_DIR}/InTreeBuild/include")

message(STATUS "Building ${PROJECT_NAME} with Qt ${Qt5Core_VERSION}")

add_subdirectory(src)

if(BUILD_TESTS)
    enable_testing()
    target_compile_definitions(${QTXDGX_LIBRARY_NAME}
        PRIVATE "QTXDG_TESTS=\"1\""
    )
    add_subdirectory(test)
else()
    message(STATUS "")
    message(STATUS "For building tests use -DBUILD_TESTS=Yes option.")
    message(STATUS "")
endif()

if (BUILD_DEV_UTILS)
    add_subdirectory(util)
endif()

configure_package_config_file(
    "${PROJECT_SOURCE_DIR}/cmake/${QTXDGX_FILE_NAME}-config.cmake.in"
    "${CMAKE_BINARY_DIR}/${QTXDGX_FILE_NAME}-config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${QTXDGX_FILE_NAME}"
)

write_basic_package_version_file(
    "${CMAKE_BINARY_DIR}/${QTXDGX_FILE_NAME}-config-version.cmake"
    VERSION ${QTXDG_VERSION_STRING}
    COMPATIBILITY AnyNewerVersion
)

configure_package_config_file(
    "${PROJECT_SOURCE_DIR}/cmake/${QTXDGX_ICONLOADER_FILE_NAME}-config.cmake.in"
    "${CMAKE_BINARY_DIR}/${QTXDGX_ICONLOADER_FILE_NAME}-config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${QTXDGX_ICONLOADER_FILE_NAME}"
)

write_basic_package_version_file(
    "${CMAKE_BINARY_DIR}/${QTXDGX_ICONLOADER_FILE_NAME}-config-version.cmake"
    VERSION ${QTXDG_VERSION_STRING}
    COMPATIBILITY AnyNewerVersion
)

ukui_create_pkgconfig_file(
    PACKAGE_NAME ${QTXDGX_LIBRARY_NAME}
    DESCRIPTIVE_NAME ${QTXDGX_LIBRARY_NAME}
    DESCRIPTION ${QTXDGX_PKG_CONFIG_DESCRIPTION}
    INCLUDEDIRS ${QTXDGX_FILE_NAME}
    LIBS ${QTXDGX_LIBRARY_NAME}
    REQUIRES ${QTXDGX_PKG_CONFIG_REQUIRES}
    REQUIRES_PRIVATE ${QTXDGX_ICONLOADER_LIBRARY_NAME}
    VERSION ${QTXDG_VERSION_STRING}
    INSTALL
)

ukui_create_pkgconfig_file(
    PACKAGE_NAME ${QTXDGX_ICONLOADER_LIBRARY_NAME}
    DESCRIPTIVE_NAME ${QTXDGX_ICONLOADER_LIBRARY_NAME}
    DESCRIPTION ${QTXDGX_ICONLOADER_PKG_CONFIG_DESCRIPTION}
    INCLUDEDIRS ${QTXDGX_ICONLOADER_FILE_NAME}
    LIBS ${QTXDGX_ICONLOADER_LIBRARY_NAME}
    REQUIRES ${QTXDGX_ICONLOADER_PKG_CONFIG_REQUIRES}
    VERSION ${QTXDG_VERSION_STRING}
    INSTALL
)

install(FILES
    "${CMAKE_BINARY_DIR}/${QTXDGX_FILE_NAME}-config.cmake"
    "${CMAKE_BINARY_DIR}/${QTXDGX_FILE_NAME}-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${QTXDGX_FILE_NAME}"
    COMPONENT Devel
)

install(FILES
    "${CMAKE_BINARY_DIR}/${QTXDGX_ICONLOADER_FILE_NAME}-config.cmake"
    "${CMAKE_BINARY_DIR}/${QTXDGX_ICONLOADER_FILE_NAME}-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${QTXDGX_ICONLOADER_FILE_NAME}"
    COMPONENT Devel
)

install(EXPORT
    "${QTXDGX_FILE_NAME}-targets"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${QTXDGX_FILE_NAME}"
    FILE "${QTXDGX_FILE_NAME}-targets.cmake"
    COMPONENT Devel
)

install(EXPORT
    "${QTXDGX_ICONLOADER_FILE_NAME}-targets"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${QTXDGX_ICONLOADER_FILE_NAME}"
    FILE "${QTXDGX_ICONLOADER_FILE_NAME}-targets.cmake"
    COMPONENT Devel
)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

#add_custom_target(uninstall
#    COMMAND ${CMAKE_COMMAND} -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== panel/xdg/src/CMakeLists.txt ===
add_subdirectory(xdgiconloader)
add_subdirectory(qtxdg)
add_subdirectory(tools)

=== debian/changelog ===
ukui-panel (3.0.3-1) unstable; urgency=medium

  * New upstream bugfix release.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 28 Sep 2020 10:31:19 +0800

ukui-panel (3.0.2-1) unstable; urgency=medium

  * New upstream bugfix release.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sun, 27 Sep 2020 18:50:43 +0800

ukui-panel (3.0.1-1) unstable; urgency=medium

  * New upstream release.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sat, 01 Aug 2020 03:11:43 +0000

ukui-panel (3.0.0-1) unstable; urgency=medium

  * New upstream release.
  * debian:
    - Update ukui-panel.postinst.
    - Update copyright.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 27 Jul 2020 01:05:06 +0000

ukui-panel (2.0.7-1) unstable; urgency=medium

  * New upstream bugfix release:
    - Fix that panel stuck after invoke ukui-control-center.
    - Fix that night mode causes the screen flicker.
    - Don't exit if ukui-window-switch does not exist.
  * debian/control:
    - Add ukui-window-switch to suggests.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Thu, 16 Apr 2020 16:33:48 +0800

=== debian/control ===
Source: ukui-panel
Section: x11
Priority: optional
Maintainer: kylin Team <team+kylin@tracker.debian.org>
Uploaders: Aron Xu <aron@debian.org>,
           handsome_feng <jianfengli@ubuntukylin.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libasound2-dev,
               libdbusmenu-qt5-dev,
               libglib2.0-dev(>=2.36),
               libicu-dev,
               libkf5solid-dev,
               libkf5windowsystem-dev,
               libpulse-dev,
               libqt5svg5-dev,
               libqt5x11extras5-dev,
               libsensors4-dev [!hurd-any],
               libstatgrab-dev [linux-any],
               libx11-dev,
               libxcb-damage0-dev,
               libxcb-util0-dev,
               libxcb-xkb-dev,
               libxcomposite-dev,
               libxdamage-dev,
               libxkbcommon-dev,
               libxkbcommon-x11-dev,
               libxrender-dev,
               libqt5webkit5-dev,
               libqt5xdg-dev,
               qttools5-dev,
               libgsettings-qt-dev,
               libdconf-dev,
               qtbase5-dev,
               qtbase5-dev-tools,
               qttools5-dev-tools,
               qtbase5-private-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Browser: https://github.com/ukui/ukui-panel
Vcs-Git: https://github.com/ukui/ukui-panel
Homepage: https://github.com/ukui/ukui-panel

Package: ukui-panel
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Provides: ukui-indicators
Suggests: ukui-window-switch
Description: ukui desktop panel
 The ukui desktop panel is used on ukui desktop and has some plugins like
 starmenu, quicklaunch and other useful tools.
 .
 This package contains the ukui panel.

=== debian/rules ===
#!/usr/bin/make -f
# export DH_VERBOSE=1

export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

WHICH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)

ifeq ($(WHICH_OS), kfreebsd)
    NOT_LINUX := -DCPULOAD_PLUGIN=NO -DNETWORKMONITOR_PLUGIN=NO -DVOLUME_PLUGIN=NO
endif

ifeq ($(WHICH_OS), hurd)
    NOT_LINUX := -DCPULOAD_PLUGIN=NO -DNETWORKMONITOR_PLUGIN=NO -DVOLUME_PLUGIN=NO -DSENSORS_PLUGIN=NO
endif

%:
	dh ${@} --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure --\
		-DPULL_TRANSLATIONS=OFF \
		-DUPDATE_TRANSLATIONS=OFF \
		-DDOM_PLUGIN=OFF \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		$(NOT_LINUX)

## ukui-panel 3.0.3.1

=== plugin-taskbar/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,6 @@
     ukuigrouppopup.h
     ukuitaskwidget.h
     ukuitaskclosebutton.h
-	ukuitaskbaricon.h
 )
 
 set(SOURCES
@@ -19,7 +18,6 @@
     ukuigrouppopup.cpp
     ukuitaskwidget.cpp
     ukuitaskclosebutton.cpp
-    ukuitaskbaricon.cpp
 )
 
 find_package(X11 REQUIRED)

=== debian/changelog ===
ukui-panel (3.0.3.1-1) unstable; urgency=medium

  * Fix the error caused by ukuitaskbaricon.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Fri, 19 Mar 2021 08:52:41 +0000
